package helper_methods;

import oop.Person;

/*
 * Poor version of code which "smells" (with lots of duplicates) 
 */
public class PersonCollectorImproved {
	private final int MAX = 100; /* max # of persons to be stored */  
	private Person[] ps;
	private int nop; /* number of persons */

	public PersonCollectorImproved() { 
		this.ps = new Person[MAX]; 
	} 
	public void addPerson(Person p) { 
		this.ps[this.nop] = p; 
		this.nop++; 
	} 

	/*  Tasks:
	 *  1. An accessor: boolean personExists(String n)
	 *  2. A mutator: void changeWeightOf(String n, double w)
	 *  3. A mutator: void changeHeightOf(String n, double h)
	 */

	public boolean personExists(String n) {
		int index = this.indexOfPerson(n);
		return index >= 0;
	} 

	public void changeWeightOf(String n, double w) {
		int index = this.indexOfPerson(n);
		if(index >= 0) {
			this.ps[index].setWeight(w);
		}
	}

	public void changeHeightOf(String n, double h) {
		int index = this.indexOfPerson(n);
		if(index >= 0) {
			this.ps[index].setHeight(h);
		}
	}
	
	/* Return the index of person with matching name.
	 * Return -1 if no persons in the array `ps` has the matching name.  
	 */
	private int indexOfPerson(String n) {
		int index = -1;
		
		for(int i = 0; i < this.nop; i ++) {
			if(this.ps[i].getName().equals(n)) { 
				index = i;
			} 
		}
		
		return index;
	}
}











